/***************************************************************************
                          filter_oe4.cxx  -  description
                             -------------------
    begin                : Thu Aug 24 2000
    copyright            : (C) 2000 by Hans Dijkema
    email                : kmailcvt@hum.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "filter_oe4.hxx"
#include "oe4_2mbox.h"
#include "harray.hxx"

#include <kfiledialog.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>

filter_oe4::filter_oe4() : filter("Import folders from Outlook Express 4")
{}

filter_oe4::~filter_oe4()
{}

void filter_oe4::import(filterInfo *info,QWidget *parent)
{
char     dir[1024];
QString  choosen;
char msg[1024];

   sprintf(dir,getenv("HOME"));

   info->alert("Import Outlook Express 4","Stephan B. Nedregrd kindly contributed the oe4 import code!\n\n"
                                          "Select the Outlook Express 4 directory on "
                                          "your system.\nUse the Mail subdirectory!\n\n"
                                          "This import filter wil search for folders\n"
                                          "(the '.mbx' files)\n\n"
                                          "NOTE: You won't get back your original folder-\n"
                                          "structure, only the folders themselves are\n"
                                          "imported. But you'll probably only do this\n"
                                          "one time ;-).\n\n"
                                          "NOTE: Kmailcvt takes the same foldernames\n"
                                          "as the Outlook Express foldernames, but precedes\n"
                                          "them with 'OE4-'. If this causes trouble to you\n"
                                          "(you've got kmail folders beginning with 'OE4-')\n"
                                          "cancel this import function (next dialog will\n"
                                          "let you do that and rename the existing kmail\n"
                                          "folders.\n\n"
                                          "LAST NOTE: Don't run kmail while this conversion\n"
                                          "takes place!"
                                          );

   choosen=KDirDialog::getDirectory(dir,parent,"Importoe4");
   if (choosen.length()==0) { return; } // No directory choosen here!
   strcpy(dir,choosen);

   sprintf(msg,"Searching for Outlook '.mbx' folders in directory");
   info->log(msg);
   sprintf(msg,"  '%s'",dir);
   info->log(msg);

   {DIR *d;
    struct dirent *entry;
      d=opendir(dir);
      if (d==NULL) {char msg[1024];
        sprintf(msg,"Can't open directory '%s'",dir);
        info->alert("Import Outlook Express 4",msg);
      }
      else {int   N=0,n=0;
            float perc;

        entry=readdir(d);
        while (entry!=NULL) {char *file=entry->d_name;
          if (strlen(file)>4 && strcasecmp(&file[strlen(file)-4],".mbx")==0) {
            N+=1;
          }
          entry=readdir(d);
        }
        if (N==0) {
          info->alert("Import Outlook Express 4","No '.mbx' folders found!");
        }
        rewinddir(d);

        info->overall();

        entry=readdir(d);
        while (entry!=NULL) {char *file=entry->d_name;

          n+=1;
          perc=(((float) n)/((float) N))*100.0;
          info->overall(perc);

          if (strlen(file)>4 && strcasecmp(&file[strlen(file)-4],".mbx")==0) {
            {
              char fldr[1024],name[256];

              sprintf(fldr,"%s/%s",dir,file);
              sprintf(name,"%s",file);name[strlen(name)-4]='\0';

              info->from(fldr);
              {char msg[1024];
                sprintf(msg,"OE4-%s",name);
                info->to(msg);
              }

              sprintf(msg,"  importing folder '%s' to kmail '%s'...",file,name);
              info->log(msg);

              {oe4_2mbox m(fldr,name,this,info);
                m.convert();
              }
            }
          }
          entry=readdir(d);
        }
        closedir(d);

        if (N!=0) {
          info->log("done.");
          info->current();info->current(100.0);
          info->overall();info->overall(100.0);
          info->alert("Import Outlook Express 4","All '.mbx' folders are imported");
        }
      }
   }
}
